function c=karatsuba(a,b)
% C=karatsuba(a, b) calcola il prootto di due polinomi a e b 
% con il metodo di Karatsuba.
% fa uso di sue funzioni polysum che permette di sommare due polinomi 
% espressi in termne dei coefficienti, e xkmult che mostrplica un polinomio % per il mnomio x^k
n=length(a);
m=length(b);

d=max(n, m);

s=ceil(log2(d));
N=2^s;
if n<N
    na=N-n;
    a=[a, zeros(1, na)];
end
if m<N
    ma=N-m;
    b=[b, zeros(1, ma)];
end

if N==1
    c=a*b; return;
end
n2=N/2;
a1=a(1:n2); b1=b(1:n2);
length(a1)
length(b1)
a2=a(n2+1:N); b2=b(n2+1:N);
p1=karatsuba(a1, b1);
p2=karatsuba(a2, b2);
p3=karatsuba(a1+a2, b1+b2);

p3=polysum(p3, -p1);
p3=polysum(p3, -p2);

p3=xkmult(p3, n2);
p2=xkmult(p2, N);

c=polysum(p1, p3);
c=polysum(c, p2);
end

function c=polysum(a,b)

na=length(a);
nb=length(b);
if na<nb
    a=[a, zeros(1, nb-na)];
end
if nb<na
    b=[b, zeros(1, na-nb)];
end
c=a+b;
end

function b=xkmult(a, k)

b=[zeros(1, k), a];
end


